<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
    <v-layout class="fill-height" >
        <v-flex d-flex xs12 md12 sm12>
            <v-card id="mapPlace">
            </v-card>
        </v-flex>

        <v-layout class="ff" align-center justify-center>
            <v-btn v-show="this.step === 0" color="success" @click="setOrigin">انتخاب مبدا</v-btn>
            <v-btn v-show="this.step === 1" color="success" @click="setDestination">انتخاب مقصد</v-btn>
            <v-btn v-show="this.step === 2" color="primary" @click="send">تایید مسیر</v-btn>
        </v-layout>
    </v-layout>
</template>
<script>
    import {mapActions, mapMutations, mapState} from "vuex";

    export default {
        name: "resetPassword",
        data() {
            return {
                api_token: '',
                markers: [],
                center : null,
                map: null,
                step:0,
            }
        },
        mounted() {
            this.showMap();
        },
        methods: {
            ...mapMutations({
                setCenterOrigin: 'mapCargoAddress/setCenterOrigin',
                setCenterDestination: 'mapCargoAddress/setCenterDestination',
                setApiToken: 'mapCargoAddress/setApiToken',
            }),
            ...mapActions({
                sendRoute: 'mapCargoAddress/sendRoute',
            }),
            reset() {
                this.send(this.key);
                this.resetPassword();
            },
            setOrigin(){
                var origin = L.icon({
                    iconUrl: 'https://api.cedarmaps.com/v1/markers/marker-square-red.png',
                    iconSize: [82,98],
                    popupAnchor: [0, -49]
                });
                L.marker([this.center.lat,this.center.lng],{
                    icon:origin
                }).addTo(this.map);
                this.step = 1;
                this.setCenterOrigin(this.center);
                console.log(this.markers);
            },
            setDestination(){
                var origin = L.icon({
                    iconUrl: 'https://api.cedarmaps.com/v1/markers/marker-square-blue.png',
                    iconSize: [82,98],
                    popupAnchor: [0, -49]
                });
                L.marker([this.center.lat,this.center.lng],{
                    icon:origin
                }).addTo(this.map);
                this.step = 2;
                this.setCenterDestination(this.center);
                console.log(this.markers);
            },
            send(){
                this.setApiToken(this.api_token);
                this.sendRoute();
            },
            async showMap() {
                console.log("showMap");
                document.getElementById('mapPlace').innerHTML = " <div id='map' class=\"col-11\"\n" +
                    "                                     style=\"height: 100%;display: flex;justify-content: center;align-items: center;\">\n" +
                    "                                    <i style='text-align: center;z-index:900;font-size:48px;color:blue;margin-bottom:48px ' class='large material-icons' >location_on</i>\n" +
                    "                                </div>";
                L.cedarmaps.accessToken = "48050673c0ddb5f00c559fec6cf9aa5d6e1e5e74"; // See the note below on how to get an access token
                // // Getting maps info from a tileJSON source
                var tileJSONUrl = 'https://api.cedarmaps.com/v1/tiles/cedarmaps.streets.json?access_token=' + L.cedarmaps.accessToken;

                this.map = await new L.cedarmaps.map('map', tileJSONUrl);
                window.molo = this.map;
                this.map.setView([35.704484, 51.378855], 15);
                this.center = this.map.getCenter();
                //
                this.map.addEventListener('movestart', (ev) => {

                });
                this.map.addEventListener('moveend', (ev) => {
                    console.log(this.map.getCenter());
                    this.center = this.map.getCenter();
                    console.log("center" + this.center);

                });
                if (this.markers.length === 0) return;
                this.markers.map(function(marker) {
                    marker.addTo(this.map);
                });
            }
        },

        beforeRouteEnter(to, from, next) {
            if(Object.keys(to.query).length !== 0) { //if the url has query (?query)
                console.log(to.query.api_token);
                next(vm => {
                    vm.api_token = to.query.api_token
                })
            }
            next()
        }
    }
</script>
<style scoped>
    .ff {
        position: absolute;
        z-index: 900;
        width: 100%;
        display: flex;
        bottom: 0;
        margin-bottom: 16px;
    }
</style>
